//===========================================================================//
// Program......: Calculator
// Programmer...: Marcos Antonio Gambeta
// Created at...: 13/01/2004 11:00:00
// Updated at...: 14/01/2004 00:10:47
//===========================================================================//
// This program is an adaptation of an example that follows
// Visual Basic 5. The original program can be found (for those who have the
// VB5) in the folder: C:\Program Files\DevStudio\VB\samples\PGuide\calc.
// If you improve or expand the capabilities of this calculator, be sure to
// Send a copy to the author's original adaptation. In this case, I. :-)
//===========================================================================//
// Last UpDate at : 09/02/2010
// Updated by     : Paulo Srgio Duro (Vanguarda) - Americana - SP - Brasil
// vanguarda.one@gmail.com
//===========================================================================//
// Cambio de vista y colores nuevos : 19/12/2013
// por Mustafa Lpez  Alicante - Espaa
// mustalopez@gmail.com
//---------------------------------------------------------------------------//
// Change of view and new colors: 19/12/2013
// by Mustafa Lpez Alicante - Spain
// mustalopez@gmail.com
//===========================================================================//
// Added new functions: Memory value now avaliable. Now, you can put entry value from
// keyboard. HotKey for operations like "+" "-" "/" "*" and for manager menory.
// Added function that move the result of expression on ClipBoard of windows, when
// the calc is closed.
//===========================================================================//
//Follow the HotKeys
// C or c = CancelEntry_Click()
// R or r = Cancel_CLick()
// W or w = CancelMemo_Click()
// S or s = ReadMemo_Click()
// M or m = SMemo_Click()
// A or a = AddMemo_Click()
// ESC to Close
//===========================================================================//

#include "hmg.ch"
#include "common.ch"

*------------------------------------*
 Function  Calendary()  
*------------------------------------*

 PRIVATE nOp1,nOp2         // Store the values entered
 PRIVATE lDecimalFlag      // Indicates whether there is already a decimal point in value
 PRIVATE nNumOps           // Number of values entered
 PRIVATE cLastInput        // Store the last key pressed
 PRIVATE cOpFlag           // Indicates the pending operation
 PRIVATE cTempReadout
 PRIVATE nMemo             // Memory Calculator
 PRIVATE lRetu_ClipBoard
 PRIVATE DiaxNew

 Default lRetu_ClipBoard := .t.

    DEFINE WINDOW Calc      ;
      AT 060, 118           ;  
      WIDTH  1051           ;
      HEIGHT 668            ;           
      BACKCOLOR { 167 ,254 ,245 }  ; 
      NOMAXIMIZE NOMINIMIZE NOSYSMENU ;
      NOCAPTION NOSIZE TOPMOST     ;
      CHILD ;
      ON INIT Form_Load() ;
      ON RELEASE Get_Value()

      ON KEY ESCAPE ACTION Calc.Release 

      BoxShadow(006, 006, 1045, 662 ,"01cal" ,"02cal",  250,250,250  )  

       Calc.Label_01cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
       Calc.Label_02cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  

*-------------------------------------------------------------------------------------------------------------------------------*
    * LetterShadow( 020, 252,"03q","03cal","Date Day: " + DTOC(DATE()) ,"", 19,.T.,.T., 151, 223, 255 ) 
      LetterShadow( 020, 252,"03q","03cal","Date Day: " + DTOC(DATE()) ,"Arial", 19,.T.,.T., 000,000,000 , 255,255,000 ) 
     
*-------------------------------------------------------------------------------------------------------------------------------*

      NewBoxShadow( 009, 008, 1040, 656 ,"04cal" ,"05cal","06cal", .F. , .F. , .T. , 255,255,255,  023,101,012  ) 

        Calc.Label_04cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
        Calc.Label_05cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
        Calc.Label_06cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)   

*-------------------------------------------------------------------------------------------------------------------------------*

     NewBoxShadow( 068, 097, 570, 573 ,"07cal" ,"08cal ","09cal", .T. , .F. , .T. , 255,255,255,  255,255,000  ) 

        Calc.Label_07cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
        Calc.Label_08cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
        Calc.Label_09cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)   

*--------------------------------------------------------------------------------------------------------------------*
*--------------------------------------------------------------------------------------------------------------------*

     DEFINE MONTHCALENDAR Date_6 
            ROW 065  
            COL 095  
            VALUE DATE()
            FONTNAME "Arial"
            FONTSIZE 12
            TOOLTIP "Click --> Detail Calendar Day"
            ONCHANGE Nil
            FONTBOLD .T.
            FONTITALIC .T.
            FONTUNDERLINE .F.  
            FONTSTRIKEOUT .F.
            HELPID Nil
            TABSTOP .T.
            VISIBLE .T.
            NOTODAY .F.
            NOTODAYCIRCLE .F.
            WEEKNUMBERS .F.
            ONCHANGE Activate_Calendar()   
       END MONTHCALENDAR
*----------------------------------------------  Multi Calendar --------------------------------------------------------*
       Calc.Date_6.Width  := 562  
       Calc.Date_6.Height := 567  
*-----------------------------------------------------------------------------------------------------------------------*

      NewBoxShadow( 087, 761, 253, 138 ,"10cal" ,"11cal ","12cal", .T. , .F. , .T. , 255,255,255,  255,255,000  ) 

           Calc.Label_10cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
           Calc.Label_11cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
           Calc.Label_12cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)   
*-----------------------------------------------------------------------------------------------------------------------*

       DEFINE IMAGE Fondo_96
           ROW 085 ; COL 760 ; WIDTH 245 ; HEIGHT 130  
           PICTURE 'resource\clock.jpg'
           STRETCH .T.
           VISIBLE .T.
       END IMAGE

*---------------------------------------------------------------------------------------------------------------------* 

       DEFINE TIMER Timer_26 INTERVAL 1000 ACTION Calc.label_426z.value := Time()   
                       
          @ 094,922 LABEL label_426z CENTERALIGN ;    
                    FONT "Arial" SIZE 10 BOLD ITALIC BACKCOLOR {000,000,000}  FONTCOLOR { 255,255,255 }  ;  
                    WIDTH 074 HEIGHT 18 

       DEFINE TIMER Timer_36 INTERVAL 1000 ACTION  Calc.label_436z.value := SUBSTR(Time(), 1,2 )  

         @ 128,797 LABEL label_436z CENTERALIGN ; 
                    FONT "DS-Digital" SIZE 48 BOLD BACKCOLOR {255,255,255}  FONTCOLOR { 000,000,000 }  ;  
                    WIDTH 073 HEIGHT 60 
 
       DEFINE TIMER Timer_46 INTERVAL 1000 ACTION Calc.label_446z.value := SUBSTR(Time(), 4,2 )
                       
         @ 128,899 LABEL label_446z CENTERALIGN ; 
                    FONT "DS-Digital" SIZE 48 BOLD BACKCOLOR {255,255,255}  FONTCOLOR { 000,000,000 }  ;  
                    WIDTH 077 HEIGHT 60  

*----------------------------------------------------------------------------------------------------------------------*

      NewBoxShadow( 277, 753, 273, 263 ,"13cal" ,"14cal","15cal", .T. , .F. , .T. , 255,255,255,  255,255,000  ) 

           Calc.Label_13cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
           Calc.Label_14cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
           Calc.Label_15cal.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)   

*-----------------------------------------------------------------------------------------------------------------------*

      DEFINE IMAGE Fondo_97
           ROW 275 ; COL 752 ; WIDTH 265 ; HEIGHT 255 //WIDTH 255 ; HEIGHT 255 
           PICTURE 'resource\Calculator.jpg'
           STRETCH .T.
           VISIBLE .T.
       END IMAGE

*-----------------------------------------------------------------------------------------------------------------------*

      // visor
      @ 310,765 TEXTBOX ReadOut  VALUE "0." WIDTH 240 HEIGHT 25 RIGHTALIGN NOTABSTOP     //READONLY RIGHTALIGN NOTABSTOP
      @ 310,779 TEXTBOX ReadFunc VALUE " "  WIDTH  15 HEIGHT 25 RIGHTALIGN NOTABSTOP    // READONLY RIGHTALIGN NOTABSTOP
      @ 333,876 TEXTBOX ReadHide VALUE " "  WIDTH  15 HEIGHT 25 NOTABSTOP ON CHANGE EvalKeys() ON ENTER Operator_Click("=") INVISIBLE

      // 7 8 9 C CE MC
      @ 348,768 BUTTON btnN7  CAPTION "7"                                ACTION Number_Click(7)     WIDTH 32 HEIGHT 32
      @ 348,808 BUTTON btnN8  CAPTION "8"                                ACTION Number_Click(8)     WIDTH 32 HEIGHT 32
      @ 348,848 BUTTON btnN9  CAPTION "9"                                ACTION Number_Click(9)     WIDTH 32 HEIGHT 32
      @ 348,888 BUTTON btnC   CAPTION ""    PICTURE "Calculator\C.bmp"   ACTION Cancel_Click()      WIDTH 32 HEIGHT 32  // "C"
      @ 348,928 BUTTON btnCE  CAPTION ""    PICTURE "Calculator\CE.bmp"  ACTION CancelEntry_Click() WIDTH 32 HEIGHT 32  // "CE"
      @ 348,968 BUTTON btnMC  CAPTION ""    PICTURE "Calculator\MC.bmp"  ACTION CancelMemo_Click()  WIDTH 32 HEIGHT 32  // "MC"

     // 4 5 6 + - MR
      @ 388,768 BUTTON btnN4  CAPTION "4"                                ACTION Number_Click(4)     WIDTH 32 HEIGHT 32
      @ 388,808 BUTTON btnN5  CAPTION "5"                                ACTION Number_Click(5)     WIDTH 32 HEIGHT 32
      @ 388,848 BUTTON btnN6  CAPTION "6"                                ACTION Number_Click(6)     WIDTH 32 HEIGHT 32
      @ 388,888 BUTTON btnOA  CAPTION ""    PICTURE "Calculator\S.bmp"   ACTION Operator_Click("+") WIDTH 32 HEIGHT 32   // "+"
      @ 388,928 BUTTON btnOS  CAPTION ""    PICTURE "Calculator\R.bmp"   ACTION Operator_Click("-") WIDTH 32 HEIGHT 32   // "-"
      @ 388,968 BUTTON btnMR  CAPTION ""    PICTURE "Calculator\MR.bmp"  ACTION ReadMemo_Click()    WIDTH 32 HEIGHT 32   // "MR"

     // 1 2 3 X / MS
      @ 428,768 BUTTON btnN1  CAPTION "1"                                ACTION Number_Click(1)     WIDTH 32 HEIGHT 32
      @ 428,808 BUTTON btnN2  CAPTION "2"                                ACTION Number_Click(2)     WIDTH 32 HEIGHT 32
      @ 428,848 BUTTON btnN3  CAPTION "3"                                ACTION Number_Click(3)     WIDTH 32 HEIGHT 32
      @ 428,888 BUTTON btnOM  CAPTION ""    PICTURE "Calculator\X.bmp"   ACTION Operator_Click("*") WIDTH 32 HEIGHT 32    // "*"
      @ 428,928 BUTTON btnOD  CAPTION ""    PICTURE "Calculator\D.bmp"   ACTION Operator_Click("/") WIDTH 32 HEIGHT 32    // "/"
      @ 428,968 BUTTON btnMS  CAPTION ""    PICTURE "Calculator\MS.bmp"  ACTION SMemo_Click()       WIDTH 32 HEIGHT 32    // "MS"

      // 0 . = % M+
      @ 468,768 BUTTON btnN0  CAPTION "0"                                ACTION Number_Click(0)     WIDTH 72 HEIGHT 32
      @ 468,848 BUTTON btnDot CAPTION "."                                ACTION Decimal_Click()     WIDTH 32 HEIGHT 32
      @ 468,888 BUTTON btnOI  CAPTION ""    PICTURE "Calculator\I.bmp"   ACTION Operator_Click("=") WIDTH 32 HEIGHT 32    // "="
      @ 468,928 BUTTON btnOP  CAPTION "%"                                ACTION Percent_Click()     WIDTH 32 HEIGHT 32
      @ 468,968 BUTTON btnMP  CAPTION ""    PICTURE "Calculator\M+.bmp"  ACTION AddMemo_Click()     WIDTH 32 HEIGHT 32    // "M+"

*------------------------------------------------------------------------------------------------*
       
      DEFINE IMAGE Fondo_98
           ROW 575 ; COL 804 ; WIDTH 154 ; HEIGHT 50
           PICTURE 'resource\Exit00.jpg'
           STRETCH .T.
           VISIBLE .T.
      END IMAGE
     
      @ 575,805 LABEL Label_98cq VALUE "" WIDTH 150 HEIGHT 050 ACTION Calc.Release  TOOLTIP "Exit" TRANSPARENT

   END WINDOW  

     nMemo := 0
    
   SETWINDOWCURSOR ( Calc.Label_98cq.Handle, "resource\finger.cur")

   Calc.Center
   Calc.Activate  
 
   if lRetu_ClipBoard
      To_ClipBoard()
   endif

return nil

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
 
*----------------------------------*
FUNCTION Activate_Calendar()    
*----------------------------------*
   IF IsWindowActive ( Form_7) = .T. .OR. IsWindowActive ( Form_9) = .T.
      MsgStop("Error, Open Window already Calendar","Attention!")
      Calc.release
      Return
   ELSE
      calendarX( ) 
   ENDIF   

return

//---------------------------------------------------------------------------//
// The initialization routine of the form.
// Set the initial values of variables.
//---------------------------------------------------------------------------//
 Static Function Form_Load()    

    System.ClipBoard := ""

    lDecimalFlag := .f.
    nNumOps := 0
    cLastInput := "NONE"
    cOpFlag := " "
    Calc.Readout.Value := "0."
    nOp1  := 0
    nOp2  := 0
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "C" (CANCEL)
// Reset text control ReadOut and clean the variables
//---------------------------------------------------------------------------//
 Static Function Cancel_Click()

   Calc.Readout.Value := "0."
   Calc.ReadFunc.Value := ""
   nOp1 := 0
   nOp2 := 0
   Form_Load()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "CE" (CANCEL ENTRY)
// Cancel value on ReadOut (TextBox)
//---------------------------------------------------------------------------//
 Static Function CancelEntry_Click()

    Calc.Readout.Value := "0."
    lDecimalFlag := .f.
    cLastInput := "CE"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' of button "." (DECIMAL POINT)
// If the last button pressed, was an operator, show on ReadOut (TextBox)
// the value "0.". Case not, add a decimal point into ReadOut
//---------------------------------------------------------------------------//
 Static Function Decimal_Click()

    If cLastInput = "NEG"
        Calc.Readout.Value := "-0."
    ElseIf cLastInput <> "NUMS"
        Calc.Readout.Value := "0."
    EndIf
    lDecimalFlag := .t.
    cLastInput := "NUMS"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the buttons of 0 to 9 (NUMBERS KEYS)
// Add the new number into ReadOut (TextBox)
//---------------------------------------------------------------------------//
 Static Function Number_Click( nIndex )

    If cLastInput <> "NUMS"
       Calc.Readout.Value := "."
       lDecimalFlag := .f.
    EndIf
    If lDecimalFlag
       Calc.Readout.Value := Calc.Readout.Value + Str(nIndex,1)
    Else
       Calc.Readout.Value := Left(Calc.Readout.Value,At(".",Calc.Readout.Value)-1)+Str(nIndex,1)+"."
    EndIf
    If cLastInput = "NEG"
       Calc.Readout.Value := "-" + Calc.Readout.Value
    endif
    cLastInput = "NUMS"
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the button "%" (PERCENT KEY)
// Calculate and show, the percentual of first value
//---------------------------------------------------------------------------//
 Static Function Percent_Click()

   Calc.Readout.Value := AllTrim(Str(Val(Calc.Readout.Value)/100))
   Calc.ReadFunc.Value := "%"
   cLastInput := "Ops"
   cOpFlag := "%"
   nNumOps := nNumOps + 1
   lDecimalFlag := .t.
   Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// Event 'click' for the keys "+-*/=" (OPERATOR KEYS)
// If the last button pressed was a number, or part this.
// Increment the nNumOps. If a operand be present, define nOp1.
// If two operand are presenteso, define nOp1 like the result of the
// operation from nOp1 and current value and show the results
//---------------------------------------------------------------------------//
 Static Function Operator_Click( cIndex )   

    cTempReadout := Calc.Readout.Value

    Calc.ReadFunc.Value := cIndex

    If cLastInput = "NUMS"
        nNumOps := nNumOps + 1
    EndIf
    Do Case
    Case nNumOps = 0
        If cIndex = "-" .And. cLastInput <> "NEG"
            Calc.Readout.Value := "-" + Calc.Readout.Value
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 1
        nOp1 := Val( Calc.Readout.Value )
        If cIndex = "-" .And. cLastInput <> "NUMS" .And. cOpFlag <> "="
            Calc.Readout.Value := "-"
            cLastInput := "NEG"
        EndIf
    Case nNumOps = 2
        nOp2 := Val(cTempReadout)
        Do Case
        Case cOpFlag = "+"
           nOp1 := nOp1 + nOp2
        Case cOpFlag = "-"
           nOp1 := nOp1 - nOp2
        Case cOpFlag = "*"
           nOp1 := nOp1 * nOp2
        Case cOpFlag = "/"
           If nOp2 = 0
              MsgInfo("Division by 0 (zero) not allowed.","Calc")
           Else
              nOp1 := nOp1 / nOp2
           EndIf
        Case cOpFlag = "="
           nOp1 := nOp2
        Case cOpFlag = "%"
           nOp1 := nOp1 * nOp2
        Endcase
        Calc.Readout.Value := AllTrim(Str(nOp1))
        nNumOps := 1
    Endcase
    If cLastInput <> "NEG"
        cLastInput := "OPS"
        cOpFlag := cIndex
    EndIf
    Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function clean the variable used for add value into memory
//---------------------------------------------------------------------------//
 Static Function CancelMemo_Click
	nMemo := 0
	SetProperty("Calc","btnMS","FontBold",.F.)        
	Calc.ReadHide.SetFocus()
Return Nil

//---------------------------------------------------------------------------//
// This function show in ReadOut (TextBox) the value in memory (nMemo)
//---------------------------------------------------------------------------//
 Static Function ReadMemo_Click

	Local i := 0
	If !Empty(nMemo)
		Calc.Readout.Value := ""
		for i := 1 to Len(Alltrim(Str(nMemo)))
			iif(Alltrim(SubStr(Alltrim(Str(nMemo)),i,1)) # ".",;
			    Number_Click(Val(Alltrim(SubStr(Alltrim(Str(nMemo)),i,1)))),;
				iif(Len(Alltrim(Str(nMemo))) # i, Decimal_Click(),))
		next i
	endif
	Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function, move to memory (nMemo) the value of ReadOut (TxtBox)
//---------------------------------------------------------------------------//
 Static Function SMemo_Click

	if !Empty(Calc.Readout.Value) .and. Val(Calc.Readout.Value) > 0
		nMemo := Val(Calc.Readout.value)
		SetProperty("Calc","btnMS","FontBold",.T.)
		Calc.ReadHide.SetFocus()
	endif

Return Nil

//---------------------------------------------------------------------------//
// This function add the value from ReadOut (TextBox) into memory
//---------------------------------------------------------------------------//
 Static Function AddMemo_Click

	if !Empty(Calc.Readout.Value) .and. Val(Calc.Readout.Value) > 0
		nMemo := nMemo + Val(Calc.Readout.Value)
		SetProperty("Calc","btnMS","FontBold",.T.)
	endif
	Calc.ReadHide.SetFocus()

Return Nil

//---------------------------------------------------------------------------//
// This function evaluates the keys you type, to perform the functions of
// Calculator keyboard
//---------------------------------------------------------------------------//
 Static Function EvalKeys()

	Local c_Keys
	if !Empty(Calc.ReadHide.Value)
		c_Keys := Alltrim(Calc.ReadHide.Value)
		do case
			case c_Keys == "0" .or.;
				 c_Keys == "1" .or.;
				 c_Keys == "2" .or.;
				 c_Keys == "3" .or.;
				 c_Keys == "4" .or.;
				 c_Keys == "5" .or.;
				 c_Keys == "6" .or.;
				 c_Keys == "7" .or.;
				 c_Keys == "8" .or.;
				 c_Keys == "9"
					Number_Click(Val(Alltrim(c_Keys)))
			case c_Keys == "/"
					Operator_Click("/")
			case c_Keys == "*"
					Operator_Click("*")
			case c_Keys == "-"
					Operator_Click("-")
			case c_Keys == "+"
					Operator_Click("+")
			case c_Keys == "."
					Decimal_Click()
			case c_Keys == "C" .or. c_Keys == "c"
					CancelEntry_Click()
			case c_Keys == "R" .or. c_Keys == "r"
					Cancel_Click()
			case c_Keys == "W" .or. c_Keys == "w"
					CancelMemo_Click()
			case c_Keys == "S" .or. c_Keys == "s"
					ReadMemo_Click()
			case c_Keys == "M" .or. c_Keys == "m"
					SMemo_Click()
			case c_Keys == "A" .or. c_Keys == "a"
					AddMemo_Click()
		end case
		Calc.ReadHide.Value := ""
	endif

Return Nil

//---------------------------------------------------------------------------//
// This function add the result of operation into clipboard
//---------------------------------------------------------------------------//
 Static Function To_ClipBoard

	System.Clipboard := Alltrim(Str(nOp1))

Return Nil

//---------------------------------------------------------------------------//
// This function add the result of operation into nOP1 variable
//---------------------------------------------------------------------------//
 Static Function Get_Value

       nOp1 := Val(Alltrim(Calc.ReadOut.Value))

Return Nil
//===========================================================================//

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*----------------------------------------*
Function CalendarX()
*----------------------------------------*

*----------------------------------------*
* (c) Mustafa Lpez  mustalopez@gmail.com
*----------------------------------------*

    DEFINE WINDOW Form_7              ;
      AT 365,490                      ;                
      WIDTH 272                       ;
      HEIGHT 272                      ;       
      BACKCOLOR {255 ,255 ,255 }      ;  
      NOMAXIMIZE NOMINIMIZE NOSYSMENU ;
      NOCAPTION NOSIZE TOPMOST        ;
      CHILD                           ;
      ON INIT Logout() 		
 
      ON KEY ESCAPE ACTION Logout_End()    

*---------------------------------------------------------------------------------------------------------------*                 
 
      BOXBOX( 000 , 000 , 275 , 275 , "01ca",.F., 022 ,022 ,022   )   // <-----  .T. Box Undido ----> BORDER CLIENTEDGE     

             Form_7.Label_01ca.Enabled := .F.                         // <---- Necessary with Textbox ...  (write) 
*---------------------------------------------------------------------------------------------------------------*  
               
       DEFINE IMAGE Fondo_9x
           ROW 01 ; COL 01 ; WIDTH 267 ; HEIGHT 265   
           PICTURE 'resource\Calen01.jpg'             
           STRETCH .T.
           VISIBLE .T.
       END IMAGE

*-------------------------------------------  Year -----------------------------------------------------------*
          @ 050,145 LABEL Label_01x VALUE SUBSTR(DTOC(DATE()),7,4) CENTERALIGN ;  
                    FONT "Arial" SIZE 15 BOLD ITALIC BACKCOLOR  {253 ,099 ,001 } FONTCOLOR {255,255,255}   ; 
                    WIDTH 090 HEIGHT 030 
*--------------------------------------  Viewer Months -------------------------------------------------------*
         aMesSX = CMONTH (DATE())          
     
          @ 050,040 LABEL Label_12zx VALUE aMesSX ; 
                    FONT "Arial" SIZE 15 BOLD ITALIC BACKCOLOR  {253 ,099 ,001 } FONTCOLOR {255,255,255}   ; 
                    WIDTH 115 HEIGHT 30                
*-------------------------------------------  Day ------------------------------------------------------------*

          @ 075,030 LABEL Label_02x VALUE SUBSTR(DTOC(DATE()),1,2) CENTERALIGN ;
                    FONT "Arial" SIZE 90 BOLD ITALIC BACKCOLOR  {253 ,099 ,001 } FONTCOLOR {255,255,255}   ; 
                    WIDTH 190 HEIGHT 118                   
*--------------------------------------  Viewer Weekday  ------------------------------------------------------*
         DiaSem = HB_OEMTOANSI(CDOW(DATE()))  
        
          @ 195,020 LABEL Label_13zx VALUE DiaSem  CENTERALIGN ;   
                    FONT "Arial" SIZE 12 BOLD ITALIC BACKCOLOR  {253 ,099 ,001 } FONTCOLOR {255,255,255}   ; 
                    WIDTH 210 HEIGHT 28  
              
*----------------------------    Courtesy routine: Lucho Miranda   ElSalnes@telefonica.net --------------------*     

         DEFINE TIMER Timer_2x INTERVAL 1000 ACTION Form_7.label_44zx.value := Time()   
                       
         @ 218,019 LABEL label_44zx CENTERALIGN ;    
                    FONT "Arial" SIZE 12 BOLD ITALIC BACKCOLOR {253 ,099 ,001 } FONTCOLOR {255,255,255}   ; 
                    WIDTH 210 HEIGHT 28 

*---------------------------------------------------------------------------------------------------------------*                 
      
  
       @ 000,000 LABEL Label_1cx VALUE "" WIDTH 268 HEIGHT 017 ACTION Logout_End()  TOOLTIP "Exit" TRANSPARENT

       @ 021,000 LABEL Label_2cx VALUE "" WIDTH 268 HEIGHT 268 ACTION Logout()  TOOLTIP "Clik -> Calendar" TRANSPARENT

     END WINDOW  

   ACTIVATE WINDOW Form_7

return nil

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

*------------------------------------*
  FUNCTION Logout()
*------------------------------------*
   IF IsWindowActive ( Form_9) = .F.
      Action_Control()
   ENDIF   
   
return nil

*------------------------------------*
 Function Action_Control()
*------------------------------------*
 
    DiaxNew := Calc.Date_6.Value  

    DEFINE WINDOW Form_9         ;
      AT 120, 490                ;  
      WIDTH 273                  ;
      HEIGHT 270                 ;  
      BACKCOLOR {255 ,255 ,255 } ;                
      NOMAXIMIZE NOMINIMIZE NOSYSMENU ;
      NOCAPTION NOSIZE TOPMOST   ;
      CHILD                      ;
      ON INIT NotaFechaQ() 
		
      ON KEY ESCAPE ACTION Logout_End()      

      DEFINE IMAGE Fondo_10x
           ROW 00 ; COL 00 ; WIDTH 273 ; HEIGHT 265           
           PICTURE 'resource\Calen02.jpg'             
           STRETCH .T.
           VISIBLE .T.
       END IMAGE

*---------------------------------------------------------------------------------------------------------------*   

    NewBoxShadow( 065, 041, 199, 170 ,"09NQ" ,"09NX ","09ND", .T. , .F. , .T. , 255,255,255,  255,255,000  ) 


         Form_9.Label_09NQ.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
         Form_9.Label_09NX.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)  
         Form_9.Label_09ND.Enabled := .F.   // <---- Necessary with MONTHCALENDAR ,Textbox ,etc (write)   

*---------------------------------------------------------------------------------------------------------------*                 
     LetterShadow (030, 095 ,"02sx" ,"02tx","Calendar","", 15,.T.,.T., 000,255,014,255,255,255 ) 
*---------------------------------------------------------------------------------------------------------------*  
               
        DEFINE MONTHCALENDAR Control_2 
            ROW 064
            COL 040  
            VALUE DiaxNew 
            FONTNAME "Arial"
            FONTSIZE 12
            TOOLTIP "Choose new Date"
            FONTBOLD .T.
            FONTITALIC .T.      
            VISIBLE .T.   
            ONCHANGE NotaFechaZ()   
         END MONTHCALENDAR
     
     @ 000,000 LABEL Label_3cx VALUE "" WIDTH 268 HEIGHT 017 ACTION ( Form_7.Release , Form_9.Release ) TOOLTIP "Exit" TRANSPARENT

     @ 021,000 LABEL Label_4cx VALUE "" WIDTH 268 HEIGHT 268 ACTION Form_9.Release TOOLTIP "Exit Calendar" TRANSPARENT

   END WINDOW 

   ACTIVATE WINDOW Form_9

return nil


*------------------------------------*
 FUNCTION Logout_End()
*------------------------------------*

   IF IsWindowActive ( Form_9) = .T.
      Form_7.Release
      Form_9.Release
      
   ELSE
      Form_7.Release

   ENDIF   
   
return nil

*------------------------------------*
 FUNCTION NotaFechaQ() 
*------------------------------------*

 DiaxNew := Calc.Date_6.Value  

 private ProximaDatexQ := DiaxNew              
 private ProxiNumDiaxQ := SUBSTR(DTOC(ProximaDatexQ),1,2)
 private ProxiNomDiarQ := HB_OEMTOANSI( CDOW(ProximaDatexQ))  
 private ProximoMesxQ  := CMONTH ( ProximaDatexQ )    
 private ProximoAnoxQ  := SUBSTR(DTOC(ProximaDatexQ),7,4)

*------------------------------------*

      Form_7.Label_01x.VALUE  := ProximoAnoxQ   
      Form_7.Label_12zx.VALUE := ProximoMesxQ    
      Form_7.Label_02x.VALUE  := ProxiNumDiaxQ   
      Form_7.Label_13zx.VALUE := ProxiNomDiarQ  
 

RETURN 

*------------------------------------*
 FUNCTION NotaFechaZ() 
*------------------------------------*

 private ProximaDatexQ := (Form_9.Control_2.value) 
 private ProxiNumDiaxQ := SUBSTR(DTOC(ProximaDatexQ),1,2)
 private ProxiNomDiarQ := HB_OEMTOANSI( CDOW(ProximaDatexQ))  
 private ProximoMesxQ  := CMONTH ( ProximaDatexQ )    
 private ProximoAnoxQ  := SUBSTR(DTOC(ProximaDatexQ),7,4)

*------------------------------------*
      Form_7.Label_01x.VALUE  := ProximoAnoxQ   
      Form_7.Label_12zx.VALUE := ProximoMesxQ    
      Form_7.Label_02x.VALUE  := ProxiNumDiaxQ   
      Form_7.Label_13zx.VALUE := ProxiNomDiarQ  
 

RETURN 


*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
























