#include <hmg.ch>

*--------------------------------------------*
FUNCTION connect2db(dbname,lCreate)
*--------------------------------------------*
local dbo1 := sqlite3_open(dbname,lCreate)
IF Empty( dbo1 )
   msginfo("Database could not be connected!")
   RETURN nil
ENDIF
RETURN dbo1

*--------------------------------------------*
Function sql(dbo1,qstr)
*--------------------------------------------*

local table := {}
local currow := nil
local tablearr := {}
local rowarr := {}
local typesarr := {}
local current := ""
local i := 0
local j := 0
local type1 := ""
if empty(dbo1)
   msgstop("Database Connection Error!")
   return tablearr
endif
table := sqlite3_get_table(dbo1,qstr)
if sqlite3_errcode(dbo1) > 0 // error
   msgstop(sqlite3_errmsg(dbo1)+" Query is : "+qstr)
   return nil
endif
stmt := sqlite3_prepare(dbo1,qstr)
IF ! Empty( stmt )
   for i := 1 to sqlite3_column_count( stmt )
      type1 := upper(alltrim(sqlite3_column_decltype( stmt,i)))
      do case
         case type1 == "INTEGER" .or. type1 == "REAL" .or. type1 == "FLOAT" .or. type1 == "DOUBLE"
            aadd(typesarr,"N")
         case type1 == "DATE" .or. type1 == "DATETIME"
            aadd(typesarr,"D")
         case type1 == "BOOL"
            aadd(typesarr,"L")
         otherwise
            aadd(typesarr,"C")
      endcase
   next i
endif
sqlite3_reset( stmt )
if len(table) > 1
   asize(tablearr,0)
   for i := 2 to len(table)
      rowarr := table[i]
      for j := 1 to len(rowarr)
         do case
            case typesarr[j] == "D"
               cDate := substr(rowarr[j],1,4)+substr(rowarr[j],6,2)+substr(rowarr[j],9,2)
               rowarr[j] := stod(cDate)
            case typesarr[j] == "N"
               rowarr[j] := val(rowarr[j])
            case typesarr[j] == "L"
               if val(rowarr[j]) == 1
                  rowarr[j] := .t.
               else
                  rowarr[j] := .f.
               endif
         endcase
      next j
      aadd(tablearr,aclone(rowarr))
   next i
endif
return tablearr

*--------------------------------------------*
Function miscsql(dbo1,qstr)
*--------------------------------------------*

if empty(dbo1)
   msgstop("Database Connection Error!")
   return .f.
endif
sqlite3_exec(dbo1,qstr)
if sqlite3_errcode(dbo1) > 0 // error
   msgstop(sqlite3_errmsg(dbo1)+" Query is : "+qstr)
   return .f.
endif
return .t.

*--------------------------------------------*
Function C2SQL(Value)
*--------------------------------------------*

   local cValue := ""
   local ii := 0  //--> added local variable
   local cTmp := ""   //--> added local variable
    local cFormatoDaData := set(4)
   do case
      case Valtype(Value) == "N"
         cValue := AllTrim(Str(Value))

      case Valtype(Value) == "D"
         if !Empty(Value)
            cdate := dtos(value)
            cValue := "'"+substr(cDate,1,4)+"-"+substr(cDate,5,2)+"-"+substr(cDate,7,2)+"'"
         else
            cValue := "''"
         endif

      case Valtype(Value) $ "CM"
         IF Empty( Value)
            cValue="''"
         ELSE
            //-- fixed escaping single quote. Like Pascal Programming add an immediate "'"
            //-- to the single quote that precedes it. I have no choice but to use
            //-- brute force on this rather using rat() and at()
            for ii := 1 to len( value )
               if substr( value, ii, 1 ) == "'"
                  cTmp += substr( value, ii, 1 ) + "'"
                else
                  cTmp += substr( value, ii, 1 )
                endif
            next
            value := cTmp
            cValue := "'" + value+ "'"
            
         ENDIF

      case Valtype(Value) == "L"
         cValue := AllTrim(Str(iif(Value == .F., 0, 1)))

      otherwise
         cValue := "''"       // NOTE: Here we lose values we cannot convert

   endcase

//Usage: AddField(mDb, "sale", "test", "text default 'testing'")
*--------------------------------------------*
Function AddField(mDb, mTblNm, mFldNm, mFldDesc)
*--------------------------------------------*
   local lFound := (ascan(SQLITE_COLUMNS(mDb, mTblnm), {|x| upper(x[1]) == upper(mFldnm)}) > 0)
   if !lFound
      miscsql(mDb, "ALTER TABLE "+mTblNm+" ADD COLUMN "+mFldNm+" "+mFldDesc)
   endif
   return nil

// Following code is written by Grigory Filatov (Minigui\Samples\Advanced\Sqlite_2\Demo.prg)
*--------------------------------
 FUNCTION SQLITE_COLUMNS( db, cTable )
*---------------------------------------------------------------------------
* Returns an 2-dimensional array with field names and types
*---------------------------------------------------------------------------
  LOCAL aCType :=  { "SQLITE_INTEGER", "SQLITE_FLOAT", "SQLITE_TEXT", "SQLITE_BLOB", "SQLITE_NULL" }
  LOCAL aFields := {}, cStatement := "SELECT * FROM " + cTable
  LOCAL stmt, nCCount, nI, nCType

  stmt := sqlite3_prepare( db, cStatement )

  sqlite3_step( stmt )
  nCCount := sqlite3_column_count( stmt )  

  IF nCCount > 0
   FOR nI := 1 TO nCCount
      nCType := sqlite3_column_type( stmt, nI )
           AADD( aFields, { sqlite3_column_name( stmt, nI ), aCType[ nCType ] } )
   NEXT nI
  ENDIF

****************************************************************************
FUNCTION Sqlite_Cmd( _oDB_, cQuery_ )
****************************************************************************
LOCAL xRetorno_
LOCAL lSelect_
cQuery_ := ALLTRIM( cQuery_ )
cQuery_ += IIF( RIGHT( cQuery_, 1 ) <> ";", ";", "" )
lSelect_ := LEFT( UPPER( cQuery_ ), 6 ) == "SELECT"

MiscSql( _oDB_, "begin transaction" )
xRetorno_ := IIF( lSelect_, ;
                  Sql( _oDB_, cQuery_ ), ;      // Select
                  MiscSql( _oDB_, cQuery_ ) ;   // Other Operation
                )
MiscSql( _oDB_, "commit transaction" )
RETURN xRetorno_

